#include "main_lc.h"
#include "launch.h"
#include "emu.h"
#include "scrasm.h"
#include "keyasm.h"
#include "disp.h"
#include "sbfm.h"
#include "pcx.h"
#include "help.h"
#include "scrn.h"
#include "info.h"
#include "glist.h"
#include "check.h"
#include "winchar.h"
#include "mouse.h"
#include "screen.h"
#include "scan.h"
#include "shell.h"
#include "edit.h"
#include "conmenu.h"
#include "sound.h"

// DANNY REGO - December 26, 2000
#include "lcdlib.h"

//version
char szVersion[]="ArcadeOS Plus";
static char szUpdateBat[]="UPDATE.BAT";
static char szInfo1[]="Part of the PC2JAMMA project";
static char szInfo2[]="http://";
static char szInfo3[]="www.mameworld.net/pc2jamma";
static char szInfo4[]="(ArcadeOS uses some MAME source)";
static char szInfo5[]="Brian Lewis 30th Aug 2001 and Macgaiver 30th sep 2002";
WINSTRUCT ldwin;

int soundcard;
int samplerate;
int noFiltersActive;
int SavedNoFiltActive;
int noCustomContainsAll[MAX_EMUS];
int SavedNoCustomAll;
int minfiltplayers[NO_CUSTOM_LISTS];
int maxfiltplayers[NO_CUSTOM_LISTS];
int minfiltyear[NO_CUSTOM_LISTS];
int maxfiltyear[NO_CUSTOM_LISTS];
int minfiltfreq[NO_CUSTOM_LISTS];
int maxfiltfreq[NO_CUSTOM_LISTS];
int minfiltcoin[NO_CUSTOM_LISTS];
int maxfiltcoin[NO_CUSTOM_LISTS];
int minfiltx[NO_CUSTOM_LISTS];
int maxfiltx[NO_CUSTOM_LISTS];
int minfilty[NO_CUSTOM_LISTS];
int maxfilty[NO_CUSTOM_LISTS];
int filtjoy2way[NO_CUSTOM_LISTS];
int filtjoy4way[NO_CUSTOM_LISTS];
int filtjoy8way[NO_CUSTOM_LISTS];
int filtdoublejoy2way[NO_CUSTOM_LISTS];
int filtdoublejoy4way[NO_CUSTOM_LISTS];
int filtdoublejoy8way[NO_CUSTOM_LISTS];
int filtpaddle[NO_CUSTOM_LISTS];
int filtdial[NO_CUSTOM_LISTS];
int filttrackball[NO_CUSTOM_LISTS];
int filtstick[NO_CUSTOM_LISTS];
int maxfiltbuttons[NO_CUSTOM_LISTS];
int minfiltbuttons[NO_CUSTOM_LISTS];
int maxfiltdepth[NO_CUSTOM_LISTS];
int minfiltdepth[NO_CUSTOM_LISTS];
int filthorz[NO_CUSTOM_LISTS];
int filtvert[NO_CUSTOM_LISTS];
int filtvector[NO_CUSTOM_LISTS];
int filtraster[NO_CUSTOM_LISTS];

int PlayerControl;
int noCocktailMode;
int TintType;
int RunState;
int LongNames;

extern int MDwnX;
extern int MDwnY;

int SSPosition;
int nFileDrive;
int SupportedSVGA;
char *subitem;
int ShadowJoy;
int ShadowHires;
int SavedNoMR;
int SavedSL;
int SavedNeo;
int SavedVector;
int SavedUNK;
int SavedCapitalise;
int noSwapMouse;
int noWrapMenus;
int Nag;
int noUseCRC;
int StartLastGame;
int noExtArcade;
int noSkipSizeCheck;
int TempDrive;
int autorunninggame=FALSE;

char	szReturnGame[256];

int bFirstSubControl;
int WinTrans=-2;
int noflipx;
int noflipy;
int AutoRepeat;
int WindowsDPMI;
int noScaleToFit;
int noDiagonals;
int JukeDelay;
int noRotatePics;
int bHelpQuit;
PCXSTRUCT	pcxback;

int *pRandomList=NULL;
int RandomIdx;

int seedcount=0;
int ShotDelay;
int SaverSSType;
int MouseSensX;
int MouseSensY;
int nNoEmulators;
int ForeColour;
int CloneColour;
int BackColour;
int ExtraColour;
int WinColour;
int MouseEvent;
int RunningGame;
int ReRun;
//Orientation of the screen
//0 = horizontal (normal)
//1 = rotated right 90 degrees (-ror in mame)
//2 = rotated left 90 defrees  (-rol in mame)
ORIENT	ScreenOrient;
//flags
int CurEmu;
int InCabinet;
int noScanLines;
int SBPresent;
int JoyType;
int BeepFM;
int PrintHardware;
int ExtHardware;
char szTurnOff[512];
char szTurnOn[512];

int MenuLocked;
int bDefMameDir;
int SaverCount;
int noMergedROMs[MAX_EMUS];
int Capitalise;
int noUseLastShot;
int noMoveShot;
int Transparent;
int Information;
int noUnknowns;
int noInstantStart;
int FontShadow;
int DisColour;
int CustomList[MAX_EMUS];
int nOrient[MAX_EMUS];
int CustPos;
int CustMax;
int CustInst;
int CustNeo;
int noHideWarnings;
int noAutoDisable;
int noStart12Esc;
int nAutoRotate;
int nCenterX;
int nCenterY;
int noEasyCenter;
int SSMove;    // EEA Changed these 3 from noAlt...
int SSRun;     // EEA
int SSInfo;    // EEA
int CustVector;
int noShowRun;
int AllowVesa;
int ExeIndex;
int Hires;
int ArcadeH;
int ArcadeV;
int PalH;
int PalV;
int ScanH;
int ScanV;
int noMouseTrails;
int JukeBoxReturn;
int JukeBoxSave;
clock_t clocks_per_second;
short	DataSeg;
short	DosDataSeg;
short	CodeSeg;
int FontSize;
int Scheme;
int SaveScheme;
int SaveFontSize;
int WidthHor;
int WidthVer;
int HiresWidthHor;
int HiresWidthVer;
int *pWidthVar;
int nWidthIndex;
int ShiftKey;
int FlipDelay;
char szMonOptions[2][512];

// DANNY REGO
int bLCDScreen;
int nLCDSerialPort;
int nLCDBaud;
char szLCDShutdown[16];

EMULATOR	Emulators[MAX_EMUS];



int 	NoGames;
static	int	RandStart=0;

pMAMEGAME	pMameGames;
pGETFILE	pNewGames;

//our screen
pBYTE   screen;



//rotation types
char RotType[4][8]={"(All)","(Horz)","(Rot'd)","(Dis.)"};
char LongRotType[4][16]={"(All)","(Horziontal)","(Rotated)","(Disabled)"};

char  pszTextValues[1024][16];
short int nCfgValues[256];
CFGVALUE	cfgDefValues[256];
int	nNoTextVals;
int	bGotBack;
int   DispRot[MAX_EMUS];
int	CursorColour;
int   OffSet[MAX_EMUS];
char  szMameFPS[32];
char  szActFPS[16];
int	State;
int   NoNewGames;
int	LoadPos;
int	PreErrState;
int	bFirstError;
int	bFirstConfig;
int   bFistSubControl;
int	bClear;
int	noExplodeWin;
int   CurPos;
int   bFirstHelp,bExplodeFile,bExplodeConfig,bFirstInfo,bExplodeEmu,bExplodeEdit;
int	nGameIndex,nSaveIndex;
int	FilePos,ConfigPos,FileOff,ConfigOff,EmuPos,FileMax;
int	NoCfgValues;
int	bInstantInfo;
int	noShowCommand;
int	NoSaveCfgs;
int	SaverType;
int	bHasMouse;
int	nMouseSens;
int	nDblClick;
int	nMouseType;
int	MouseX,MouseY;
int   MouseDrivX,MouseDrivY;
int	ControlPos,ControlItems;
int   SubControlPos,SubControlItems;
int	*pStdPos;
int	*pStdMax;
int   nLastGame[MAX_EMUS];
int	bExplodeCustom;
int   noButtonOn[3];
int   noShiftKeys;

BYTE  keys[NO_OF_KEYS];

pCFGVALUE   pcfgSave;
WINSTRUCT	gamewin;
WINSTRUCT	cfgwin;
WINSTRUCT	emuwin;


int	EmuOffset;

int	nLogging;
int	nLogDate;
int	nClearLog;
FILE	*fLogFile;
int FirstJukeBox=TRUE;

static int bFinished;

SCHEME schemes[MAX_SCHEMES+1]=
{
    {{0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},-2,8},
    {{0,1,2,3,4,5,6,3,8,9,10,11,12,13,14,15},-2,8},
    {{2,1,3,3,4,5,6,0,10,9,10,11,12,13,14,2},-3,0},
    {{0,1,2,3,4,5,6,1,8,9,10,11,12,13,14,3},-2,1},
    {{0,1,3,3,4,5,6,4,10,9,10,11,12,13,14,2},-3,4}
};

int BIOSCab;
int SaveCab;

int _crt0_startup_flags;


int bFirstControl;

int main(int argc,char **argv)
{
   int lastgame;
	int centx,centy,maxx,maxy,minx,miny;
   int n,NoFileValues;
   int quit;
	int bFirstLoop,bFound;
   int bDirChange;
   int HelpQuit=0;
   int HelpState=0;
   int bStart2;
	clock_t ticker,tickcount,delaytick1,delaytick2,delaytick3;
   int toState;
   int cret;
	char LastGame[16];
   int nTemp;
   int bSwitch;
   int nCut;
	int ah,av;
	int ascale,atrans;
   int amx,amy;
   int amtype,shadsspos,shadgreen;
	int bRunningJuke=FALSE;
	static char buffer[1024];
	static char szTemp[1024];
	static char szCommand[512];
	int bShell=FALSE;
   int bXMas;
   int ShadowShift;



//check the type of DPMI server
	checkdpmi();

//check we've got our BIOS extensions
	if(!checkAOSBios())
	{
		printf("ArcadeOS BIOS Extensions not present\nPlease run ArcadeOS\n");
		endexefile();
		exit(EXIT_FAILURE);
	}
//get selectors
   CodeSeg=_my_cs();
	DataSeg=_my_ds();
	DosDataSeg=_dos_ds;

//install our critical error handler
	initcrit();

//get the startup dir
	startupdir();

//get SVGA info
   getmodeinfo(0x101);

//read in the the cfg values
   getcfgvalues();
//check player control is valid
   if(PlayerControl>CONTROL_PLAYER2||PlayerControl<CONTROL_PLAYER1)
      PlayerControl=CONTROL_PLAYER1;

   ShadowShift=noShiftKeys;

   bXMas=isxmas();


   pcfgSave=myalloc(CFG_ALL_SIZE);
	JukeBoxSave=SaverCount;
	JukeBoxReturn=FALSE;
	if(argc>=2)
	{
      if(argv[1][0]=='~')
      {
         ReRun=TRUE;

         strcpy(szReturnGame,&argv[1][1]);
         SupportedSVGA=atoi(argv[2]);
         if(argc==4)
         {
            if(!userescape())
            {
               JukeBoxReturn=TRUE;
               SaverCount=3;
            }
         }
      }
	}
   if(!ReRun)
	{
		*szReturnGame=0;
//get command line arguments
      if(!getcmdlineargs(argc,argv))
         return 0;
	}


//clibrate our ticker
	calibratetick();
	if(nLogging)
	{
		openlogfile();
		atexit(closelogfile);
	}

   if(SupportedSVGA)
      loginfo(1,"Found Supported SVGA chipset");
   else
      loginfo(1,"No supported SVGA chipset found");



   LongNames=_USE_LFN;

   if(LongNames)
      loginfo(1,"Long Filenames active (running in DOS Box)");
   else
      loginfo(1,"Long Filenames are NOT available (pure DOS)");


   CustMax=NO_CUSTOM_LISTS;
	CustInst=FALSE;
	MouseEvent=FALSE;


	if(!ReRun)
      srandom(time(NULL));
//check RMS files
	checkrmsfiles();
//check if we're using external rather than AOS BIOS extensions for arcade/TV video modes
   SaveCab=InCabinet;
   if(!noExtArcade)
   {
      loginfo(1,"Using External arcade/TV TSR,'incabinet' options active, but AOS BIOS extensions are off");
//turn of incabinet extensions
      BIOSCab=0;
      if(!InCabinet)
         InCabinet=1;
   }
   else
      BIOSCab=InCabinet;

   if(!SupportedSVGA&&BIOSCab)
      Hires=FALSE;



//make sure our BIOS knows what it's meant to be displaying on
   callAOSBios(SET_INCABINET,BIOSCab,0);
   if(InCabinet)
      noScanLines=1;

	if(nCenterX<-8)
		nCenterX=-8;
	if(nCenterX>8)
		nCenterX=8;
	if(nCenterY<-16)
		nCenterY=-16;
	if(nCenterY>16)
		nCenterY=16;

	centermode((char)nCenterX,(char)nCenterY);
//set the display mode
	if(ReRun)
      setgraphmode(TRUE);
   SaveFontSize=FontSize;
   if(bXMas)
   {
      Scheme=MAX_SCHEMES+SCHEME_OFFSET;
      strcpy(szVersion,"Feliz Natal !!");
   }

   SaveScheme=Scheme;

   setscreenorient();
//reset our window handler
	initwindow();
//soundcard with an FM chip ?
   SBPresent=FALSE;
   if(BeepFM)
   {
      if(DetectFM())
      {
//yep, use that for our beeps
         SBPresent=TRUE;
         ResetFM();
         SetMusicMode();
      }
   }

// DANNY REGO
// BRIAN - PLEASE LEAVE THESE LINES IN THE SOURCE (commented out at least)  THANKS!
// if it's a re-run, or we don't want to boot to the last game
// played, then set it the runstate to false otherwise, leave
// it alone, 'cause it's our last status before exiting
   if(ReRun||!StartLastGame)
     RunState=0;

	FileMax=3;
//set the mode to displaying games
	State=MENU_STATE_GAMES;
	NoNewGames=0;
	NoFileValues=3;
   WinColour=8;

   if(ShiftKey!=1&&ShiftKey!=2)
      ShiftKey=1;

   getjoysticksetup();
//save these values so we can pick up dynamic changes
	ascale=noScaleToFit;
   shadsspos=SSPosition;
   shadgreen=TintType;
	ah=ArcadeH;
	av=ArcadeV;
	amx=MouseSensX;
	amy=MouseSensY;
	amtype=nMouseType;
	atrans=Transparent;
//add all our internal strings
   setinternalcfg();
   if(InCabinet)
   {
      if(Hires)
         loginfo(1,"Arcade Monitor 640x480 Mode");
      else
      {
         switch(InCabinet)
         {
            case 1:
               loginfo(1,"Using Arcade Monitor/NTSC Mode");
               break;
            case 2:
               loginfo(1,"Using PAL TV Mode#");
               break;
         }
		}
   }
   else
   {
      if(Hires)
      {
         if(!noScanLines)
            loginfo(1,"PC Monitor 640x480 Scanline Mode");
         else
            loginfo(1,"PC Monitor 640x480 Mode");
      }
      else
      {
         if(!noScanLines)
            loginfo(1,"PC Monitor 320x200 Scanlines Mode");
         else
            loginfo(1,"PC Monitor 320x200 Mode");
      }
	}
   if(SBPresent)
      loginfo(1,"Found SB or compatible sound card (for FM)");

//check controller

   checkcontroller();
   ShadowJoy=JoyType;
   ShadowHires=Hires;
	LoadPos=0;
//allocate space for our list of games
	pMameGames=(pMAMEGAME)myalloc(GAME_LIST_SIZE);

	if(!pMameGames)
	{
      printf("Failed to allocated Memory for Game List\n");
      exitaos(EXIT_FAILURE);
	}

	pNewGames=NULL;
//read in the emulator files
	nNoEmulators=getemulators(Emulators);
	if(nNoEmulators<=0)
	{
		if(nNoEmulators==0)
			printf("No Emulators Found\n");
		myfree(pMameGames);
      exitaos(EXIT_FAILURE);
	}
   if(!Emulators[CurEmu].bSupportsRotation)
      ROTATION=0;

//do some checks
	sprintf(buffer,"%s%s",Emulators[EMU_MAME].szPath,Emulators[EMU_MAME].szExe);
	if(!checkfile(buffer))
	{
      printf("-------------------------------------------------------------\n");
      printf("ArcadeOS was unable to find MAME in the directory %s\n",Emulators[EMU_MAME].szPath);
      printf("-------------------------------------------------------------\n\n");
      printf("If MAME is in another directory\nuse the command line option \n\n arcadeos -mamepath <mame directory>\n");
      printf("\ni.e.\n\n arcadeos -mamepath c:\\games\\mame\n\n");
      printf("\nto setup ArcadeOS\nor edit the 'mamepath' entry arcadeos.cfg\n");
		myfree(pMameGames);
      exitaos(EXIT_FAILURE);
	}
	sprintf(buffer,"%s%s",Emulators[EMU_MAME].szPath,Emulators[EMU_MAME].szInfoExe);
	if(!checkfile(buffer))
	{
		printf("The supplied 'info' exe - %s\nDoes not exist or is corrupt\n",buffer);
		myfree(pMameGames);
      exitaos(EXIT_FAILURE);
	}

//see if the currently defined emulator is there
	bFound=FALSE;
	for(n=0;n<nNoEmulators;n++)
	{
		if(*Emulators[n].szPath&&n==CurEmu)
		{
			bFound=TRUE;
			break;
		}
	}
	if(!bFound)
	{
//default EMU isn't there, so use the next available one
		for(n=0;n<nNoEmulators;n++)
		{
			if(*Emulators[n].szPath)
			{
				CurEmu=n;
				break;
			}
		}
	}

//0's okay (but pointless) -1 is a bit bad
   lastgame=nLastGame[CurEmu];

   if(createlist(&NoGames,ROTATION,lastgame)<0)
	{
		myfree(pMameGames);
      exitaos(EXIT_FAILURE);
	}

   if(!setupgameinfo())
   {
      if(!makelists())
         exitaos(EXIT_FAILURE);
      if(!setupgameinfo())
      {
         myfree(pMameGames);
         printf("Unable to find or generate MAME information lists");
         exitaos(EXIT_FAILURE);
      }
   }
   setuprandomlist(NoGames);

	if(!allocpcx())
	{
      printf("Failed to allocate memory for backdrop\n");
		myfree(pMameGames);
      exitaos(EXIT_FAILURE);
	}
   nTemp=CurPos;
   if(Emulators[CurEmu].bScreenShots&&!noUseLastShot&&Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
	{
      bGotBack=getscreenshot(nTemp,FALSE,FALSE,SSMove); // EEA Changed from NoAltSSMove
      if(!bGotBack)
         bGotBack=getbackdrop();
	}
	else
		bGotBack=getbackdrop();

   if(nTemp>=0&&nTemp<Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
      strcpy(LastGame,pMameGames[CurPos].GameName);
	else
		*LastGame=0;

//allocate screen
	if(!allocscreen())
	{
      printf("Failed to Allocate Memory for display\n");
		myfree(pMameGames);
		freepcx();
      exitaos(EXIT_FAILURE);
	}

//get the config default values
   getdefcfgvals();

//and real values
   if(ReRun)
   {
      if(!readlocalcfg())
         readcfgvals();
   }
   else
      readcfgvals();


// DANNY REGO
// Re-display logo to LCD just in case.
displayLCDLogo();




	if(NoCfgValues>MAX_CFGS)
		NoCfgValues=MAX_CFGS;

	if(!ReRun)
		setgraphmode(TRUE);
//clear our screen buffer
	memset(screen,0,ScreenOrient.memsize);

   bHasMouse=CheckMouse();

//set some display stuff up
	if(!initdisp())
	{
      printf("Failed to initialise display\n");
		myfree(pMameGames);
		freepcx();
      exitaos(EXIT_FAILURE);
	}

   if(!initsoundinterface())
      exitaos(EXIT_FAILURE);

//reset the key vars
	initkey();


//replace the keyboard handler
	replace();



	if(bGotBack)
		makepcxpal();


	precalcfont();

	bFinished=FALSE;
	bFirstLoop=!ReRun;


	RunningGame=FALSE;
//clear FPS
	*szMameFPS=0;

   bClear=bFirstError=bFirstHelp=bExplodeFile=bExplodeConfig=bFirstInfo=bExplodeEmu=bExplodeEdit=TRUE;
	bInstantInfo=FALSE;
   ControlPos=SubControlPos=bFirstControl=bFistSubControl=0;


	FileOff=ConfigOff=cret=0;

   allocsnow();

   cursorcheck();

   SavedSL=noScanLines;

   if(!ReRun)
      soundinterface(SOUND_STARTUP);
//---------------
//MAIN LOOP
//---------------
	memset(keys,0,NO_OF_KEYS);
	ticker=clock();
	EmuOffset=0;
	while((CurEmu-EmuOffset)>=(ScreenOrient.NoOnScreen-6))
		EmuOffset++;
   createwin(&ldwin,2,7,20,5,0,0);


   while(!bFinished)
	{
      if(Hires && FontSize!=SaveFontSize)
      {
         fontchanged();
         SaveFontSize=FontSize;
      }

      if(Scheme!=SaveScheme)
      {
         schemechanged();
         SaveScheme=Scheme;
      }


      if(*pWidthVar!=ScreenOrient.DispWidth)
         ScreenOrient.DispWidth=*pWidthVar;

		delaytick1=clock();
		bSwitch=FALSE;
//check for backdrop change
      if(Emulators[CurEmu].bScreenShots&&!noMoveShot&&(cret!=-1||Information>INFO_OFFSET+2))
		{
//is it out of range ?
         if(CurPos<0||CurPos>=Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
			{
//yep, so have we set it to the std. backdrop yet ?
				if(!strcmp(LastGame,STANDARD_BACKDROP))
				{
//yep
					bSwitch=FALSE;
				}
				else
				{
//nope
					bGotBack=getbackdrop();
					strcpy(LastGame,STANDARD_BACKDROP);
					bSwitch=bGotBack;
				}
            nLastGame[CurEmu]=CurPos;
			}
			else
			{
//in range, so has it changed ?
            if(CurPos!=nLastGame[CurEmu])
				{
//yep, try and get a new backdrop
               bGotBack=getscreenshot(CurPos,FALSE,FALSE,SSMove); // EEA Changed from !noAltSSMove
					if(bGotBack)
						bSwitch=TRUE;
					else
					{
						bGotBack=TRUE;
						bSwitch=FALSE;
					}
               nLastGame[CurEmu]=CurPos;
				}
			}
		}
      if(cret!=-1)
         nLastGame[CurEmu]=CurPos;


		if(bSwitch)
			makepcxpal();



//clear the buffer
		if(bClear)
			clearscreen();

		bClear=TRUE;
//check which state we're in
		if(ReRun)
			mameerror(szMameFPS);
		switch(State)
		{
         case MENU_STATE_AOS_CONFIG:
            showgames();
            controlmenu(&bFirstControl,TRUE,bFirstControl);
            subcontrolmenu();
            break;

         case MENU_STATE_DOS_SHELL:
            *LastGame=0;
  				runcommand("command.com",FALSE,TRUE,NULL,NULL,FALSE,NULL);
				showrunwindow("DOS Shell",0,12,0);
				bFinished=TRUE;
	  			RunningGame=TRUE;
				bShell=TRUE;
            break;
         case MENU_STATE_GAMES:
            showgames();
				break;
			case MENU_STATE_TEST:
				dispcentre(ScreenOrient.maxy-6,"Left/Right Up/Down",ForeColour,0,ScreenOrient.maxx+2,TRUE,0,2,DISP_FONT);
				dispcentre(ScreenOrient.maxy-5,"to Center Screen",ForeColour,0,ScreenOrient.maxx+2,TRUE,0,2,DISP_FONT);
				dispcentre(ScreenOrient.maxy,"Start 2 to Exit",ExtraColour,0,ScreenOrient.maxx+2,TRUE,0,0,DISP_FONT);
				break;
			case MENU_STATE_CONVERGENCE:
				testpatterns();
				dispcentre(ScreenOrient.maxy-5,"Button 1 for next screen",ForeColour,0,ScreenOrient.maxx+2,TRUE,0,2,DISP_FONT);
				dispcentre(ScreenOrient.maxy,"Start 2 to Exit",ExtraColour,0,ScreenOrient.maxx+2,TRUE,0,0,DISP_FONT);
				break;

			case MENU_STATE_UPDATE_GAMES:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
				break;
			case MENU_STATE_CUSTOM:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
            showcustom(SHOW_CUSTOM_LIST);
				break;

			case MENU_STATE_CUSTOM_SET:
            showgames();
				if(!CustInst)
					controlmenu(&bFirstControl,TRUE,FALSE);
				showcustom(CUSTOM_CHOOSE);
				break;

			case MENU_STATE_EMULATOR:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
				emumenu();
				break;
         case MENU_STATE_EDIT:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
            editmenu();
            break;

         case MENU_STATE_CONTROL:
            showgames();
				ControlItems=controlmenu(&bFirstControl,TRUE,bFirstControl);
				break;


			case MENU_STATE_CHECK:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
				checkresults(pMameGames[nGameIndex].GameName);
				break;

//the load menu
			case MENU_STATE_SET_LOAD:
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
				setmenu();
				bExplodeFile=FALSE;
				break;
//game info
			case MENU_STATE_INFO:
            dispinfo(CurPos,bFirstInfo);
				bFirstInfo=FALSE;
				break;
//online help
			case MENU_STATE_HELP:
				bHelpQuit=!disphelp(HelpState,bFirstHelp,szVersion);
				bFirstHelp=FALSE;
				break;
			case MENU_STATE_README:
         case MENU_STATE_AOS_README:
				HelpState=MENU_STATE_CONTROL;
				bHelpQuit=!dispreadme(bFirstHelp);
				bFirstHelp=FALSE;
				break;
//unziping new emulator or running update.bat
			case MENU_STATE_LOAD_MAME:
			case MENU_STATE_RUN_UPDATE:
				break;
//displaying an error
			case MENU_STATE_ERROR:
            showgames();
            if(bFirstError)
               soundinterface(SOUND_ERROR);
				disperror();
				bFirstError=FALSE;
				break;

//displaying the config menu
			case MENU_STATE_CONFIG:
				nCut=13;
            showgames();
				controlmenu(&bFirstControl,TRUE,FALSE);
				if(nGameIndex>=0)
					sprintf(buffer,"%s Config",pMameGames[nGameIndex].GameName);
				else
				{
					if(nGameIndex==-2)
					{
                  strcpy(buffer,subitem);
                  subcontrolmenu();
						nCut=14;
					}
					else
						strcpy(buffer,"Default Config");

				}

            if(NoCfgValues<=(ScreenOrient.NoOnScreen-1))
				{
					cfgwin.bHasScrollBar=FALSE;
					nTemp=NoCfgValues;
				}
				else
				{
					cfgwin.bHasScrollBar=TRUE;
               nTemp=ScreenOrient.NoOnScreen-1;
				}

            createwin(&cfgwin,3,0,27,nTemp,0,5);

				cfgwin.winproc=cfgproc;
				pStdPos=&ConfigPos;
				pStdMax=&NoCfgValues;

				registerwindow(&cfgwin);


				drawwindow(&cfgwin,WinColour,TRUE,bExplodeConfig,buffer);
				dispcursorbar(ConfigPos,ConfigOff,24,4,2);
				if(NoCfgValues>ScreenOrient.NoOnScreen)
               cfgwin.scrollpos=drawscrollbar(&cfgwin,&ConfigPos,NoCfgValues,cfgwin.control);

				dispcfgs(nCut);
            dispcentre(nTemp+2,"Start 2 to Close",ExtraColour,4,24,TRUE,0,2,DISP_FONT);
				bFirstConfig=FALSE;
				bExplodeConfig=FALSE;
				break;

//loading roms
			case MENU_STATE_LOAD_ROMS:
            showgames();
				setmenu();

				bDirChange=FALSE;
//show our screen
				if(LoadPos>=NoNewGames)
				{

					drawwindow(&ldwin,1,TRUE,FALSE,"Add ROMS");
					dispcentre(10,"Updating List",ExtraColour,3,18,TRUE,0,0,DISP_FONT);
					flipscreen(FALSE);
					myfree(pNewGames);
					State=MENU_STATE_SET_LOAD;
               createlist(&NoGames,ROTATION,0);
					CurPos=0;
               OffSet[CurEmu]=0;
					bClear=TRUE;
				}
				else
				{
					sprintf(buffer,"Adding %s",pNewGames[LoadPos].FileName);
					drawwindow(&ldwin,1,TRUE,FALSE,"Add ROMS");
					dispcentre(10,buffer,ExtraColour,3,18,TRUE,0,0,DISP_FONT);
					flipscreen(FALSE);
//do we have a ziproms directory ?
					if(*Emulators[CurEmu].szZipPath)
					{
//yep, so just copy to that
						makefullpath(Emulators[CurEmu].szZipPath,buffer,CurEmu);
                  sprintf(szCommand,"copy a:%s.zip %s /Y",pNewGames[LoadPos].FileName,buffer);
					}
					else
					{
//no zip roms directory, do we have a 'single' directory
						if(*Emulators[CurEmu].szSingle)
                  {
							makefullpath(Emulators[CurEmu].szSingle,buffer,CurEmu);
						}
						else
						{
//no single directory, roms directory ?
							if(*Emulators[CurEmu].szRomsDir)
							{
								getitem(szTemp,Emulators[CurEmu].szRomsDir,0,255,';');
//yep,
								makefullpath(szTemp,buffer,CurEmu);
							}
							else
							{
//no directories found, so use the base one
								strcpy(buffer,Emulators[CurEmu].szPath);
//make sure we haven't got a
								checkpath(buffer);
							}

						}
//yep, do we support zips ?
						if(Emulators[CurEmu].bZipFiles)
						{
//yep, so just copy it to the directory
                     sprintf(szCommand,"copy a:%s.zip %s /Y",pNewGames[LoadPos].FileName,buffer);
						}
						else
						{
//no zip support,so we need to make the directory and everything
							godir(buffer);
							mkdir(pNewGames[LoadPos].FileName,0);
							chdir(pNewGames[LoadPos].FileName);
							sprintf(szCommand,"pkunzip a:%s.zip /d /n",pNewGames[LoadPos].FileName);
							bDirChange=TRUE;
						}
					}

					strcat(szCommand," >c:\\mx$.tmp");
//clear the cirtical flag
					critclear();

					runcommand(szCommand,FALSE,FALSE,NULL,NULL,FALSE,NULL);

					unlink("c:\\mx$.tmp");
//go back to where we were
					if(bDirChange)
						menudir();

					LoadPos++;

				}

            break;
		}



//show our screen
		if(bSwitch)
			setpcxpal(pcxback.palette);
      if(bXMas)
         drawsnow();
//check for autorun
      if(bFirstLoop)
      {
         switch(StartLastGame)
         {
            case START_OFFSET+1: //autorun if game has been run
               if(RunState)
                  autorunninggame=TRUE;
               break;
            case START_OFFSET+2: //run regardless
               autorunninggame=TRUE;
               break;
         }
      }


      if(autorunninggame)
      {
         if(!noShowRun)
            flipscreen(TRUE);
      }
      else
         flipscreen(TRUE);

		if(atrans!=Transparent)
      {
         atrans=Transparent;
			makepcxpal();
      }

      if(ascale!=noScaleToFit||shadsspos!=SSPosition||shadgreen!=TintType)
      {
         nLastGame[CurEmu]=-1;
         ascale=noScaleToFit;
         shadsspos=SSPosition;
         shadgreen=TintType;
		}

      if(ah!=ArcadeH||av!=ArcadeV)
      {
         ah=ArcadeH;
         av=ArcadeV;
         settiming();
      }

      if(amtype!=nMouseType)
      {
         makearcadeosconfig(8);
         amtype=nMouseType;
      }

      if(amx!=MouseSensX||amy!=MouseSensY)
		{
			amx=MouseSensX;
			amy=MouseSensY;
         setmousesens();
      }

      if(!ReRun&&InCabinet&&bFirstLoop)
		{
//are we writing to the printer ?
         if(!cabonoff(CAB_ON))
            beep(3);
		}

      if(ShadowJoy!=JoyType)
      {
         makearcadeosconfig(7);
         ShadowJoy=JoyType;
         checkcontroller();
         JoyType=ShadowJoy;
      }

      if(ShadowHires!=Hires)
      {
         Hires=ShadowHires;
         fontchanged();
         freescreen();
         allocscreen();
         freepcx();
         allocpcx();
         setgraphmode(FALSE);
         nLastGame[CurEmu]=-1;
         setmousesens();
      }

      if(ShadowShift!=noShiftKeys)
      {
         makearcadeosconfig(9);
         ShadowShift=noShiftKeys;
      }

      if(SavedSL!=noScanLines)
      {
         if(!Hires)
            setgraphmode(FALSE);
         nLastGame[CurEmu]=-1;
         SavedSL=noScanLines;
      }
      ReRun=0;
//check what's going on keywise
		nTemp=readkey();
//get joystick/mouse events
		nTemp|=handlekeyjoy(!autorepeat(ConfigPos,cfgDefValues));

      if(autorunninggame)
         setstart();

      bFirstLoop=FALSE;
      if(nTemp||MouseEvent)
		{
			ticker=clock();
			if(JukeBoxReturn&&FirstJukeBox)
			{
				FirstJukeBox=FALSE;
				SaverCount=JukeBoxSave;
			}
		}

		MouseEvent=FALSE;
      if(RandStart)
         setstart();
		RandStart=0;
//escape ?
		quit=FALSE;
		bStart2=keys[K_START2]|keys[K_CLOSEWIN];
		switch(State)
		{
         case MENU_STATE_AOS_CONFIG:
            if(bStart2)
            {
               State=MENU_STATE_CONTROL;
               bClear=TRUE;
               quit=TRUE;
               restoldconfig();
            }
            break;
         case MENU_STATE_HELP:
			case MENU_STATE_README:
         case MENU_STATE_AOS_README:
				if(bHelpQuit||bStart2)
				{
					State=HelpState;
					bFirstConfig=TRUE;
					bClear=TRUE;
					quit=TRUE;
				}
				break;
			case	MENU_STATE_CHECK:
				if(bStart2)
				{
					State=MENU_STATE_CONTROL;
					bClear=TRUE;
					quit=TRUE;
					quitcheck();
				}
				break;

			case	MENU_STATE_TEST:
				if(bStart2)
				{
					resetpat();
					State=MENU_STATE_CONTROL;
					bClear=TRUE;
					quit=TRUE;

				}
				break;
			case	MENU_STATE_CONVERGENCE:
				if(bStart2)
				{
					State=MENU_STATE_CONTROL;
					bClear=TRUE;
					quit=TRUE;
				}
				break;

			case MENU_STATE_CUSTOM_SET:
				if(bStart2)
				{
					if(CustInst)
						State=MENU_STATE_GAMES;
					else
						State=MENU_STATE_CONTROL;

						bClear=TRUE;
					quit=TRUE;
					CustInst=FALSE;
				}
				break;
			case	MENU_STATE_CONTROL:
				if(bStart2)
				{
               State=MENU_STATE_GAMES;
					bClear=TRUE;
					quit=TRUE;
				}
				break;
			case MENU_STATE_ERROR:
				if(bStart2)
				{
					State=PreErrState;
					quit=TRUE;
					bClear=TRUE;
					bExplodeFile=FALSE;
				}
				break;
			case MENU_STATE_CUSTOM:
			case MENU_STATE_SET_LOAD:
			case MENU_STATE_CONFIG:
			case MENU_STATE_INFO:
			case MENU_STATE_EMULATOR:
         case MENU_STATE_EDIT:
				toState=MENU_STATE_CONTROL;
				if(bStart2)
				{
					if(State==MENU_STATE_CONFIG)
					{
						if(nGameIndex>=0)
						{
							if(pMameGames[nGameIndex].bLocalConfig)
							{
								for(n=0;n<MAX_CFGS;n++)
									pMameGames[nGameIndex].nConfigs[n]=nCfgValues[n];
							}
						}
						else
						{
							if(nGameIndex==-1)
                     {
                        int bwrite=FALSE;
                        for(n=0;n<MAX_CFGS;n++)
                        {
                           if(cfgDefValues[n].nValue!=nCfgValues[n])
                              bwrite=TRUE;
									cfgDefValues[n].nValue=nCfgValues[n];
                        }
                        if(bwrite)
                        {
                           writeemucfg(FALSE,TRUE);
                           writelocalcfg();
                        }
                     }
							else
                     {
                        switch(SubControlPos)
                        {
                           case 6:
                              updatekeys();
                              break;
                           case 7:
                              updatejoys();
                              break;
                           case 9:
                              updateshifts();
                              break;
                        }
                        toState=MENU_STATE_AOS_CONFIG;
                     }
						}
					}
					if(State==MENU_STATE_INFO)
					{
						if(noUseLastShot)
							clearscreenshot();
						if(bInstantInfo)
							toState=MENU_STATE_GAMES;
						cleartext();
					}
					bInstantInfo=FALSE;
					State=toState;
					nGameIndex=nSaveIndex;
					LoadPos=0;
					bClear=TRUE;
					quit=TRUE;
				}
				break;
			default:
				if(keys[K_ESC])
				{
					bFinished=TRUE;
					quit=TRUE;
					RunningGame=FALSE;
				}
				break;
		}

//yep, check what it means

		if(!quit)
		{
//check for online help
			if(keys[K_2_B3])
			{
				switch(State)
				{
               case MENU_STATE_HELP:
               case MENU_STATE_README:
               case MENU_STATE_AOS_README:
               case MENU_STATE_ERROR:
               case MENU_STATE_LOAD_ROMS:
               case MENU_STATE_INFO:
               case MENU_STATE_CHECK:
						break;
					default:
						HelpState=State;
						bFirstHelp=TRUE;
						State=MENU_STATE_HELP;
						bClear=FALSE;

				}
			}
//check for file,config or info
			if(State==MENU_STATE_GAMES&&keys[K_START2]&&!MenuLocked)
			{
				State=MENU_STATE_CONTROL;
            nGameIndex=CurPos;
				nSaveIndex=nGameIndex;
				ControlPos=0;
				bFirstControl=TRUE;

			}
			else
			{
//no mode changes,so move the cursor around a bit
				switch(State)
				{
               case MENU_STATE_AOS_CONFIG:
                  movesubconfig();
                  break;
               case MENU_STATE_GAMES:
                  cret=movecursor(&Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION],&ROTATION);
						if(cret==TRUE)
						{
							bFinished=TRUE;
							RunningGame=TRUE;
                     RunState=1;
						}
                  if(cret==FALSE)
                     RunState=0;


						break;
					case MENU_STATE_CONFIG:
						movecfgcursor(&ConfigPos,&NoCfgValues,&ConfigOff,cfgDefValues,nGameIndex);
						break;
					case MENU_STATE_SET_LOAD:
						movefilecursor(&FilePos,&NoFileValues,&FileOff);
						break;
					case MENU_STATE_CONTROL:
						movecontcursor(&ControlPos,&ControlItems);
						break;
					case MENU_STATE_README:
               case MENU_STATE_AOS_README:
						movereadmecursor();
						break;
					case MENU_STATE_CHECK:
						movecheckcursor();
						break;
					case MENU_STATE_EMULATOR:
						moveemu();
						break;
					case MENU_STATE_CUSTOM_SET:
						movecustom(CUSTOM_CHOOSE);
						break;
					case MENU_STATE_CUSTOM:
                  movecustom(SHOW_CUSTOM_LIST);
						break;
					case MENU_STATE_TEST:
						movecenter();
						break;
					case MENU_STATE_CONVERGENCE:
						nexttest();
						break;
					default:
						break;
				}
			}
		}

		delaytick2=clock();

		delaytick3=delaytick2-delaytick1;
      updatesound();
		if(delaytick3<1)
		{
			while(TRUE)
			{
            updatesound();
				delaytick1=clock();
				delaytick3=delaytick1-delaytick2;
				if(delaytick3>=CLICK_DELAY)
					break;
			}
		}

		delaytick3=clock();
		if((clock_t)delaytick3>(clock_t)ticker)
		{
			tickcount=(clock_t)((clock_t)delaytick3-(clock_t)ticker);
			nTemp=checkscrsave(tickcount);
			switch(nTemp)
			{
				case TRUE:
					ticker=clock();
					break;
				case JUKEBOX_RETURN:
					bFinished=TRUE;
					RunningGame=TRUE;
					bRunningJuke=TRUE;
			}
		}
	}

   if(!RunningGame)
      soundinterface(SOUND_SHUTDOWN);

// DANNY REGO
   if(!RunningGame)
     displayLCDShutdown();

	if(JukeBoxReturn)
		SaverCount=JukeBoxSave;
   freesnow();
//---------------
//END OF MAIN LOOP
//---------------
//write out the game configs
   writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);

   cleargameinfo();

	myfree(pMameGames);
	if(pNewGames)
		myfree(pNewGames);

	if(!RunningGame)
	{

		if(!Hires)
			melt();
      if(soundcard)
         tofromdot(-1);
      else
         tofromdot(-5);


		memset(screen,0,ScreenOrient.memsize);
		flipscreen(FALSE);



      if(InCabinet)
		{
			dispstring(0,0,szVersion,ExtraColour,FALSE,0,0,DISP_FONT);
			dispstring(0,2,szInfo1,ForeColour,FALSE,0,0,DISP_FONT);
			dispstring(0,5,szInfo3,CloneColour,FALSE,0,0,DISP_FONT);
			dispstring(0,7,szInfo4,CloneColour,FALSE,0,0,DISP_FONT);
			dispstring(0,9,szInfo5,CloneColour,FALSE,0,0,DISP_FONT);
			if(ScreenOrient.Orientation==ORIENT_NORMAL)
				printf("\n\n\n\n\n\n\n\n\n\n\n");
			flipscreen(FALSE);
		}
      else
         setgmode(3);

	}

   clearsoundinterface();




	NoCfgValues=0;



   freescreen();
   freepcx();
   clearfonts();
   clearhelp();
   unlink("c:\\x.tmp");




   if(bShell)
      setgmode(3);
//exit banner

	if(!RunningGame)
	{
      if(!InCabinet)
		{
			printf("%s\n",szVersion);
			printf("\n%s\n%s%s\n%s\n%s\n",szInfo1,szInfo2,szInfo3,szInfo4,szInfo5);
		}
		else
		{
         if(!cabonoff(CAB_OFF))
            beep(1);
		}
      endexefile();
	}
//write out mame config
//   if(!RunningGame)
  //    writeemucfg(FALSE,FALSE);

   if(bHasMouse)
      CheckMouse();


	clearkbuff();
   InCabinet=SaveCab;
   writecfgvalues();

//put back the old keyboard handler
	putback();

   if(pcfgSave)
      myfree(pcfgSave);

//and exit the program
	exit(EXIT_SUCCESS);
}

void moveemu(void)
{
	int	dummy=0;
   if(startpressed())
	{
		if(EmuPos!=CurEmu)
		{
         changeemu(EmuPos);
			State=MENU_STATE_GAMES;
		}
	}
	else
		handlemovement(&EmuPos,&nNoEmulators,&EmuOffset,(ScreenOrient.NoOnScreen-6));

}

void emumenu()
{
	int	n,tot;
	tot=nNoEmulators;
	if(tot>ScreenOrient.NoOnScreen-6)
	{
		tot=ScreenOrient.NoOnScreen-6;
		emuwin.bHasScrollBar=TRUE;
	}
	else
		emuwin.bHasScrollBar=FALSE;
   createwin(&emuwin,2,4,18,tot+4,0,0);
	emuwin.winproc=emuproc;

	pStdPos=&EmuPos;
	pStdMax=&nNoEmulators;
	registerwindow(&emuwin);

	drawwindow(&emuwin,WinColour,TRUE,bExplodeEmu,"Emulator Menu");
	dispcursorbar(EmuPos,EmuOffset,16,3,6);
	if(emuwin.bHasScrollBar)
        emuwin.scrollpos=drawscrollbar(&emuwin,&EmuPos,nNoEmulators,emuwin.control);

	if((nNoEmulators-EmuOffset)<tot)
		tot=nNoEmulators-EmuOffset;
	for(n=0;n<tot;n++)
		dispstring(3,n+6,Emulators[n+EmuOffset].szEmuName,ForeColour,TRUE,0,0,DISP_FONT);
	dispcentre(tot+6,"Start 2 to Close",ExtraColour,3,16,TRUE,0,0,DISP_FONT);
	bExplodeEmu=FALSE;

}
void setmenu(void)
{
	int	w;
	WINSTRUCT	winstruct;
	char	buffer[256];

	w=23;
	sprintf(buffer,"add roms to %s",Emulators[CurEmu].szEmuName);
   createwin(&winstruct,3,6,w,8,0,0);
	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=&FilePos;
	pStdMax=&FileMax;
	registerwindow(&winstruct);

   if(nFileDrive<(FILE_OFFSET+2))
      sprintf(buffer,"Insert Disk into %c:",getfiledrive());
   else
      sprintf(buffer,"Using Disk %c:",getfiledrive());

   drawwindow(&winstruct,WinColour,TRUE,bExplodeFile,buffer);
   dispcursorbar(FilePos,FileOff,w-2,4,8);
	sprintf(buffer,"Add ROMS to %s",Emulators[CurEmu].szEmuName);
	dispstring(4,8,buffer,ForeColour,(FilePos==0),0,0,DISP_FONT);
	sprintf(buffer,"Update %s",Emulators[CurEmu].szEmuName);
	dispstring(4,9,buffer,ForeColour,(FilePos==1),0,0,DISP_FONT);
	sprintf(buffer,"Run %s",szUpdateBat);
	dispstring(4,10,szUpdateBat,ForeColour,(FilePos==2),0,0,DISP_FONT);
	dispcentre(12,"Start 2 to Close",ExtraColour,4,w-2,TRUE,0,0,DISP_FONT);
}

int controlmenu(int *bFirst,int Shadow,int Explode)
{
   int ypos,DynaCol;
	WINSTRUCT	winstruct;
   if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
		DynaCol=ForeColour;
	else
		DynaCol=DisColour;

   createwin(&winstruct,1,2,21,19,0,0);

	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=&ControlPos;
	pStdMax=&ControlItems;
	registerwindow(&winstruct);
	drawwindow(&winstruct,WinColour,Shadow,Explode,"Control Menu");
	dispcursorbar(ControlPos,0,19,2,4);
	ypos=4;
//see what we're going to display
	dispstring(2,ypos++,"Game Config",DynaCol,TRUE,0,0,DISP_FONT);
//only show these 2 for MAME
	if(CurEmu==EMU_MAME)
	{
		dispstring(2,ypos++,"Game Info",DynaCol,TRUE,0,0,DISP_FONT);
		dispstring(2,ypos++,"Check ROMS",DynaCol,TRUE,0,0,DISP_FONT);
	}

   dispstring(2,ypos++,"Emu Info",DynaCol,TRUE,0,0,DISP_FONT);
   dispstring(2,ypos++,"Move to Custom List",DynaCol,TRUE,0,0,DISP_FONT);
	dispstring(2,ypos++,"Display Custom List",ForeColour,TRUE,0,0,DISP_FONT);

	dispstring(2,ypos++,"Default Config",ForeColour,TRUE,0,0,DISP_FONT);
   dispstring(2,ypos++,"ArcadeOS Config",ExtraColour,TRUE,0,0,DISP_FONT);

	if(CurEmu!=EMU_MAME)
		dispstring(2,ypos++,"Update Game Names",ForeColour,TRUE,0,0,DISP_FONT);


	dispstring(2,ypos++,"File Menu",ForeColour,TRUE,0,0,DISP_FONT);
	dispstring(2,ypos++,"Center Screen",ForeColour,TRUE,0,0,DISP_FONT);
	dispstring(2,ypos++,"Test Patterns",ForeColour,TRUE,0,0,DISP_FONT);
   dispstring(2,ypos++,"DOS Shell",ForeColour,TRUE,0,0,DISP_FONT);
	dispstring(2,ypos++,"Change Emu",ForeColour,TRUE,0,0,DISP_FONT);
	dispstring(2,ypos++,"Exit ArcadeOS",ForeColour,TRUE,0,0,DISP_FONT);

   dispcentre(19,"Start 2 to Close",ExtraColour,2,18,TRUE,0,0,DISP_FONT);

	*bFirst=FALSE;
	return (ypos-4);
}

pBYTE allocscreen()
{
	screen=myalloc(ScreenOrient.memsize);
	return screen;
}

void freescreen()
{
	myfree(screen);
}


int checkscrsave(clock_t tickcount)
{
   int seconds;
	if(SaverCount)
	{
		seconds=tickcount/clocks_per_second;
		if(seconds>=SaverCount)
			return screensaver(SaverType);
	}
	return FALSE;
}

int autorepeat(int nindex,pCFGVALUE pcfgValues)
{
	if(State!=MENU_STATE_CONFIG)
		return FALSE;

   if((pcfgValues[nindex].max-pcfgValues[nindex].min)>90)
		return TRUE;

	return FALSE;
}


void movecontcursor(int *CPos,int *pNoValues)
{
	int	dummy=0;
	int	nindex,n,res;
	int	bGoAhead=FALSE;
	char	szUpdate[256];
	WINSTRUCT updwin;


	switch(*CPos)
	{

      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 7:
			if(CurEmu==EMU_MAME)
				nindex=*CPos;
			else
				nindex=*CPos+2;
			break;
      case 8:
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
      case 14:
			if(CurEmu==EMU_MAME)
				nindex=*CPos+1;
			else
				nindex=*CPos+2;
			break;
		default:
			nindex=*CPos;
			break;

	}

   if(startpressed())
	{
		switch(nindex)
		{

         case  0: //Config
            if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0||bGoAhead)
				{
					State=MENU_STATE_CONFIG;
//see if config's local to this game
					if(nGameIndex>=0)
					{
						pMameGames[nGameIndex].bChanged=TRUE;
						if(pMameGames[nGameIndex].bLocalConfig)
						{
							for(n=0;n<MAX_CFGS;n++)
							{
								nCfgValues[n]=pMameGames[nGameIndex].nConfigs[n];
								if(nCfgValues[n]<cfgDefValues[n].min)
									nCfgValues[n]=cfgDefValues[n].min;
								if(nCfgValues[n]>cfgDefValues[n].max)
									nCfgValues[n]=cfgDefValues[n].max;
							}
						}
						else
						{
							for(n=0;n<MAX_CFGS;n++)
								nCfgValues[n]=cfgDefValues[n].nValue;
						}
					}
					else
					{
                  for(n=0;n<MAX_CFGS;n++)
                     nCfgValues[n]=cfgDefValues[n].nValue;
					}
					bFirstConfig=TRUE;
					bExplodeConfig=TRUE;
					ConfigPos=0;
					ConfigOff=0;
				}
				break;
         case  1: //info
            if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
				{
					State=MENU_STATE_INFO;
					bFirstInfo=TRUE;
				}
				break;

         case  2: //check roms
            if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
				{
					drawwindow(&ldwin,1,TRUE,FALSE,pMameGames[nGameIndex].GameName);
               dispcentre(10,"Checking ROMS",ExtraColour,3,18,TRUE,0,0,DISP_FONT);
					flipscreen(FALSE);
					checkroms(pMameGames[nGameIndex].GameName,&State);
				}
				break;

         case  3: //Emu Info
				bFirstHelp=TRUE;
				State=MENU_STATE_README;
				break;

         case  4: //Custom Lists
            if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
				{
					nSaveIndex=nGameIndex;
					State=MENU_STATE_CUSTOM_SET;
					bExplodeCustom=TRUE;
               CustPos=CUSTOM_LIST;
				}
				break;
         case  5: //Custom Lists
				nSaveIndex=nGameIndex;
				State=MENU_STATE_CUSTOM;
				bExplodeCustom=TRUE;
            CustPos=CUSTOM_LIST;
				break;
         case  6: //Default config
				if(nGameIndex>=0)
					nGameIndex=-1;
				bGoAhead=TRUE;
            State=MENU_STATE_CONFIG;
            for(n=0;n<MAX_CFGS;n++)
               nCfgValues[n]=cfgDefValues[n].nValue;
            bFirstConfig=TRUE;
            bExplodeConfig=TRUE;
            ConfigPos=0;
            ConfigOff=0;
            break;
         case  7: //ArcadeOS Config
            SubControlPos=0;
            bFirstSubControl=TRUE;
            State=MENU_STATE_AOS_CONFIG;
            break;

         case 8: //Update game names
            createwin(&updwin,2,8,21,6,0,0);
				drawwindow(&updwin,1,TRUE,FALSE,"Control Menu");
				dispcentre(11,"Updating Game Names",ExtraColour,3,20,TRUE,0,0,DISP_FONT);
				flipscreen(FALSE);

				if(!checkfile(Emulators[CurEmu].szUpdateExe))
				{
					sprintf(szUpdate,"Can't Find '%s'",Emulators[CurEmu].szUpdateExe);
					seterror("Error Updating Games",szUpdate);
					return;
				}
				else
				{
//run update.bat
					critclear();
					sprintf(szUpdate,"%s %s %s",Emulators[CurEmu].szUpdateExe,Emulators[CurEmu].szPath,Emulators[CurEmu].szRomsDir);
               res=runcommand(szUpdate,FALSE,FALSE,NULL,NULL,FALSE,NULL);
					if(readcrit()||res)
					{
						generror();
						return;
					}
				}
//go to here, so reload games
				reloadgames(FALSE);
				break;

         case 9: //File menu
				FilePos=0;
				FileOff=0;
				State=MENU_STATE_SET_LOAD;
				bExplodeFile=TRUE;
				break;
         case 10:
				State=MENU_STATE_TEST;
				setuppat();
				break;
         case 11:   //test patterns
				State=MENU_STATE_CONVERGENCE;
				resettest();
				break;
         case 12: //DOS Shell
            State=MENU_STATE_DOS_SHELL;
            break;
         case 13: //change emu
				State=MENU_STATE_EMULATOR;
				EmuPos=CurEmu;
				bExplodeEmu=TRUE;
				break;
         case 14:   //exit arcadeos
				bFinished=TRUE;
				RunningGame=FALSE;
				break;
		}
	}
	else
		handlemovement(CPos,pNoValues,&dummy,ScreenOrient.NoOnScreen);


}

void movefilecursor(int *pCurPos,int *pNoValues,int *pOffSet)
{
	int	bres,res;
	char * pWork;
	static char	buffer[256];
	static char	szTemp[64];
	static char	szCommand[64];
	WINSTRUCT	mfwin;


   if(startpressed())
	{
		switch(*pCurPos)
		{
			case 0:
//load in new roms
				strcpy(buffer,"Adding ROMS");
            createwin(&mfwin,2,8,strlen(buffer)+2,4,4,2);
				drawwindow(&mfwin,1,TRUE,FALSE,"File Menu");
				dispstring(4,11,buffer,ExtraColour,TRUE,0,0,DISP_FONT);
				flipscreen(FALSE);


				critclear();
				pNewGames=myalloc(sizeof(MAMEGAME)*MAX_NEW_GAMES);
//get a list of all .zips on A:

            sprintf(buffer,"%c:*.zip",getfiledrive());
            bres=getallfiles(pNewGames,&NoNewGames,buffer,FA_ARCH,GAME_TYPE_ZIP,MAX_NEW_GAMES);
				if(readcrit())
				{
					myfree(pNewGames);
					generror();
					return;
				}
				else
				{
					if(bres>0)
					{
						State=MENU_STATE_LOAD_ROMS;
						CurPos=0;
                  OffSet[CurEmu]=0;
						LoadPos=0;
						bClear=TRUE;
					}
				}
				break;
//load in new emulator
			case 1:
				sprintf(buffer,"Unzipping %s",Emulators[CurEmu].szEmuName);
                createwin(&mfwin,2,8,strlen(buffer)+2,4,4,2);
				drawwindow(&mfwin,1,TRUE,FALSE,"File Menu");
				dispstring(4,11,buffer,ExtraColour,TRUE,0,0,DISP_FONT);
				flipscreen(FALSE);

				strcpy(szTemp,Emulators[CurEmu].szExe);
				pWork=strstr(szTemp,".");
				if(pWork)
					*pWork=0;
				strcat(szTemp,".zip");
            sprintf(buffer,"%c:%s",getfiledrive(),szTemp);
				if(!checkfile(buffer))
				{
					generror();
					return;
				}
				else
				{
//got here okay , so run pkunzip
					critclear();
					emudir(NULL);
					sprintf(szCommand,"pkunzip %s /d /n >c:\\x.tmp",buffer);
               res=runcommand(szCommand,FALSE,FALSE,NULL,NULL,FALSE,NULL);
					menudir();
					if(readcrit()||res)
					{
						generror();
						return;
					}
					else
					{
//go back to the control menu
						State=MENU_STATE_CONTROL;
						nGameIndex=nSaveIndex;
						bClear=TRUE;
					}
				}
				break;

			case 2:
//run update.bat
            createwin(&mfwin,2,8,strlen("Running UPDATE")+2,4,4,2);
				drawwindow(&mfwin,1,TRUE,FALSE,"File Menu");
				dispcentre(11,"Running UPDATE",ExtraColour,3,18,TRUE,0,0,DISP_FONT);
				flipscreen(FALSE);
            sprintf(buffer,"%c:%s",getfiledrive(),szUpdateBat);
            if(!checkfile(buffer))
				{
					generror();
					return;
				}
				else
				{
//run update.bat
					critclear();
               res=runcommand(buffer,FALSE,FALSE,NULL,NULL,FALSE,NULL);
					if(readcrit()||res)
					{
						generror();
						return;
					}
					else
					{
//go back to the games
						State=MENU_STATE_GAMES;
						CurPos=0;
                  OffSet[CurEmu]=0;
					}
				}
				break;
		}
	}
	else
	{
		handlemovement(pCurPos,pNoValues,pOffSet,ScreenOrient.NoOnScreen);
	}
}

void showgames()
{
   int nTemp,n,xpos;
	static char	buffer[1024];
	static char	szCommand[1024];
   int work;
   char *pName;

   if(Information>INFO_OFFSET+2)
   {

      if(Information>INFO_OFFSET+3)
      {
         pName=pMameGames[CurPos].szDispName;
         work=(ScreenOrient.maxx-strlen(pName))/2;
         for(n=0;n<strlen(pName);n++)
            shadowchar(n+work,ScreenOrient.maxy,DISP_FONT);
         dispcentre(ScreenOrient.maxy,pName,ForeColour,0,ScreenOrient.maxx,TRUE,0,0,DISP_FONT);
      }
      return;
   }

	if(MenuLocked)
		sprintf(buffer,"%sL",szVersion);
	else
		strcpy(buffer,szVersion);


   createwin(&gamewin,0,0,ScreenOrient.DispWidth+4,ScreenOrient.NoOnScreen,1,3);
	gamewin.winproc=gamesproc;
   if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>ScreenOrient.NoOnScreen)
		gamewin.bHasScrollBar=TRUE;
	else
		gamewin.bHasScrollBar=FALSE;


	registerwindow(&gamewin);
	drawwindow(&gamewin,-1,FALSE,FALSE,buffer);

   xpos=(12-strlen(Emulators[CurEmu].szCustomList[CUSTOM_LIST]))/2;
   dispstring(15+xpos,0,Emulators[CurEmu].szCustomList[CUSTOM_LIST],ExtraColour,TRUE,2,4,FALSE);


   dispchar(15,0,WIN_BOX_TL,WinTrans,FALSE,0,0,FALSE);
   dispchar(15,1,WIN_BOX_BL,WinTrans,FALSE,0,0,FALSE);
	for(n=16;n<26;n++)
	{
        dispchar(n,0,WIN_BOX_TH,WinTrans,FALSE,0,0,FALSE);
        dispchar(n,1,WIN_BOX_BH,WinTrans,FALSE,0,0,FALSE);
	}

    dispchar(n,0,WIN_BOX_TR,WinTrans,FALSE,0,0,FALSE);
    dispchar(n,1,WIN_BOX_BR,WinTrans,FALSE,0,0,FALSE);

	if(CurPos<0)
		nTemp=0;
	else
		nTemp=CurPos;
   dispcursorbar(nTemp,OffSet[CurEmu],ScreenOrient.DispWidth+2,1,2);



   if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>ScreenOrient.NoOnScreen)
        gamewin.scrollpos=drawscrollbar(&gamewin,&CurPos,Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION],gamewin.control);

	dispgames();



   if(Information>INFO_OFFSET)
	{
		getFPS(szActFPS,szMameFPS);
      sprintf(buffer,"%d of %d ",CurPos+1,Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
		dispstring(0,ScreenOrient.maxy,buffer,ForeColour,TRUE,2,4,DISP_FONT);
		if(Hires)
		{
			work=strlen(buffer);
         dispstring(work,ScreenOrient.maxy,LongRotType[ROTATION],ExtraColour,TRUE,2,4,DISP_FONT);
         work+=(strlen(LongRotType[ROTATION])+2);
			if(isdigit(*szActFPS))
			{
				dispstring(work,ScreenOrient.maxy,"FPS:",ForeColour,TRUE,2,4,DISP_FONT);
				work+=5;
				dispstring(work,ScreenOrient.maxy,szActFPS,ExtraColour,TRUE,2,4,DISP_FONT);
				work+=(strlen(szActFPS)+2);
				dispstring(work,ScreenOrient.maxy,"Emulator:",ForeColour,TRUE,2,4,DISP_FONT);
				work+=10;
				dispstring(work,ScreenOrient.maxy,Emulators[CurEmu].szEmuName,ExtraColour,TRUE,2,4,DISP_FONT);
			}
			else
			{
				dispstring(work,ScreenOrient.maxy,"Emulator:",ForeColour,TRUE,2,4,DISP_FONT);
				work+=10;
				dispstring(work,ScreenOrient.maxy,Emulators[CurEmu].szEmuName,ExtraColour,TRUE,2,4,DISP_FONT);
			}

		}
		else
		{
         sprintf(szCommand,"%s %s %s",RotType[ROTATION],szActFPS,Emulators[CurEmu].szEmuName);
			dispstring(strlen(buffer),ScreenOrient.maxy,szCommand,ExtraColour,TRUE,2,4,DISP_FONT);
		}
	}

}

int getbackdrop()
{
   return loadpcx(Emulators[CurEmu].szBackdrop,&pcxback);
}

int handlekeyjoy(int bStopRepeat)
{
	int   joybuttons,injoyx,injoyy;
	int	n,i,saveval;
	short int	mx,my,mbutt;
   int nbut;
	int	nMUp,nMDown,nMLeft,nMRight,nRet;
	static BYTE bFirst=TRUE;
	static BYTE AutoRep[NO_OF_KEYS];

	static	BYTE	bDownCnt[3]={0,0,0};
	static	BYTE	bUpCnt[3]={100,100,100};
	static	BYTE	bDblClk[3]={0,0,0};
	static	BYTE	bTypeRate[NO_OF_KEYS];

	if(bFirst)
	{
		bFirst=FALSE;
		memset(AutoRep,0,NO_OF_KEYS);
		memset(bTypeRate,0,NO_OF_KEYS);
	}

//copy over joypad buttons (if one is present)
   nRet=handlejoystick();
//copy over mouse buttons
	if(bHasMouse)
	{
		if(nMouseSens<0)
		{
			nMUp=K_DOWN;
			nMDown=K_UP;
			nMLeft=K_RIGHT;
			nMRight=K_LEFT;
		}
		else
		{
			nMUp=K_UP;
			nMDown=K_DOWN;
			nMLeft=K_LEFT;
			nMRight=K_RIGHT;
		}

		ReadMouse(&mbutt,&mx,&my);
		i=1;
		for(n=0;n<3;n++)
		{
			if(mbutt==n+1||mbutt==i)
			{
				bUpCnt[n]=0;
				if(!bDownCnt[n])
				{
					MDwnX=MouseX;
					MDwnY=MouseY;
				}
            sendmessage(WM_LDOWN+n);
				bDownCnt[n]++;
				if(!bDownCnt[n])
					bDownCnt[n]=1;
				MouseEvent=TRUE;
			}
			else
			{
				if(bDownCnt[n])
				{
					if(nMouseType==STANDARD_MOUSE)
					{
						MouseEvent=TRUE;
						sendmessage(WM_LUP+n);
					}
					else
					{
						switch(n)
						{
							case 0:
                        setstart();
								break;
							case 1:
								keys[K_START2]=1;
								break;
							case 2:
								keys[K_COIN1]=1;
								break;
						}
					}
//check for a double click
					if(bDownCnt[n]<=nDblClick)
					{
						bDblClk[n]++;
						if(!bDblClk[n])
							bDblClk[n]=1;
						if(bDblClk[n]>1)
						{
							if(nMouseType==STANDARD_MOUSE)
								sendmessage(WM_LDBLCLICK+n);
							bDblClk[n]=0;
						}
					}
					bDownCnt[n]=0;
				}


				bUpCnt[n]++;
				if(!bUpCnt[n])
					bUpCnt[n]=3;
//check for too long between clicks
				if(bDblClk[n]&&bUpCnt[n]>nDblClick)
					bDblClk[n]=0;

			}
			i<<=1;

		}

		if(my<-abs(nMouseSens))
			mousemove(nMUp);

		if(my>abs(nMouseSens))
			mousemove(nMDown);

		if(mx<-abs(nMouseSens))
			mousemove(nMLeft);

		if(mx>abs(nMouseSens))
			mousemove(nMRight);

	}

   for(n=K_B1;n<=K_CUSTLIST;n++)
	{
//make buttons nonrepeating
		if(bStopRepeat)
		{
			saveval=keys[n];
			if(keys[n]&&!AutoRep[n])
				keys[n]=1;
			else
				keys[n]=0;

			AutoRep[n]=saveval;
		}
		else
		{
			if(!keys[n])
				bTypeRate[n]=0;
			else
			{
				if(!bTypeRate[n]||bTypeRate[n]>=AutoRepeat)
				{
					if(!bTypeRate[n])
						bTypeRate[n]=1;
					keys[n]=1;
				}
				else
				{
					bTypeRate[n]+=1;
					keys[n]=0;
				}
			}
			AutoRep[n]=keys[n];
		}
	}
//sneaky hidden screen shot key
    if(keys[K_SSHOT])
		savesshot();
//typeamtic rate stuff
   for(i=0;i<2;i++)
   {
      for(n=K_UP;n<=K_RIGHT;n++)
      {
         if(!keys[n+KEY_P2])
            bTypeRate[n+KEY_P2]=0;
         else
         {
            if(!bTypeRate[n+KEY_P2]||bTypeRate[n+KEY_P2]>=AutoRepeat)
            {
               if(!bTypeRate[n+KEY_P2])
                  bTypeRate[n+KEY_P2]=1;
               keys[n+KEY_P2]=1;
            }
            else
            {
               bTypeRate[n+KEY_P2]+=1;
               keys[n+KEY_P2]=0;
            }
         }
		}
	}
	return nRet;
}



void movecfgcursor(int *pCfgPos,int *pNoCfgValues,int *pCfgOff,pCFGVALUE pcfgValues,int nIndex)
{

	int	n;
	int	bSet=FALSE;
	int	bVal;


   while((*pCfgPos-*pCfgOff)>=ScreenOrient.NoOnScreen&&*pCfgOff<(*pNoCfgValues-ScreenOrient.NoOnScreen))
      *pCfgOff+=1;
   while(*pCfgOff>*pCfgPos&&*pCfgOff>0)
      *pCfgOff-=1;
   if(*pCfgPos<0)
      *pCfgPos=0;
   if(*pCfgOff<0)
      *pCfgOff=0;

   if(*pCfgPos>=*pNoCfgValues)
      *pCfgPos=*pNoCfgValues-1;
   if(*pCfgOff+ScreenOrient.NoOnScreen>=*pNoCfgValues)
	{
      *pCfgOff=*pNoCfgValues-ScreenOrient.NoOnScreen;
      if(*pCfgOff<0)
         *pCfgOff=0;
	}


//button 1, decrease value
	if(keys[K_B1])
	{
		nCfgValues[*pCfgPos]-=1;
		if(nCfgValues[*pCfgPos]<pcfgValues[*pCfgPos].min)
			nCfgValues[*pCfgPos]=pcfgValues[*pCfgPos].max;
		bSet=TRUE;
	}
//button 2, increase value
   if(keys[K_B2]||startpressed())
	{
		nCfgValues[*pCfgPos]+=1;
		if(nCfgValues[*pCfgPos]>pcfgValues[*pCfgPos].max)
			nCfgValues[*pCfgPos]=pcfgValues[*pCfgPos].min;
		bSet=TRUE;
	}

//button 3, set value to default
	if(keys[K_B3])
	{
		nCfgValues[*pCfgPos]=pcfgValues[*pCfgPos].nValue;
		if(nIndex==-2)
      {
         if(pcfgValues[*pCfgPos].CfgType==CFG_BYTE)
            *pcfgValues[*pCfgPos].pbArcValue=(BYTE)pcfgValues[*pCfgPos].nValue;
         else
            *pcfgValues[*pCfgPos].pArcValue=pcfgValues[*pCfgPos].nValue;
      }


		bSet=TRUE;
	}
//button 1 player 2, set all to default values
   if(p2button1())
	{
		for(n=0;n<*pNoCfgValues;n++)
		{
			nCfgValues[n]=pcfgValues[n].nValue;
			if(nIndex==-2)
         {
            if(pcfgValues[*pCfgPos].CfgType==CFG_BYTE)
               *pcfgValues[n].pbArcValue=(BYTE)pcfgValues[n].nValue;
            else
               *pcfgValues[n].pArcValue=pcfgValues[n].nValue;
         }
		}
		bSet=TRUE;
	}
	if(bSet)
	{
		if(nIndex>=0)
		{
			bVal=FALSE;
			for(n=0;n<MAX_CFGS;n++)
			{
				if(nCfgValues[n]!=pcfgValues[n].nValue)
				{
					bVal=TRUE;
					break;
				}
			}
			pMameGames[nIndex].bLocalConfig=bVal;
		}
		else
		{
			if(nIndex==-2)
         {

            if(pcfgValues[*pCfgPos].CfgType==CFG_BYTE)
               *pcfgValues[*pCfgPos].pbArcValue=(BYTE)nCfgValues[*pCfgPos];
            else
               *pcfgValues[*pCfgPos].pArcValue=nCfgValues[*pCfgPos];
         }
		}

		return;
	}
	handlemovement(pCfgPos,pNoCfgValues,pCfgOff,ScreenOrient.NoOnScreen);
}


int movecursor(int *pNoGames,int *pDispRot)
{

	int	DataCur;
	int	nSave[MAX_CFGS];
	int	n,temp;
   int   Orient;
	static char szWork[256];

   DataCur=CurPos;
//start 1 , launch the game
   if(startpressed())
	{
		if(pMameGames[DataCur].bLocalConfig)
		{
			for(n=0;n<MAX_CFGS;n++)
			{
				nSave[n]=cfgDefValues[n].nValue;
				cfgDefValues[n].nValue=pMameGames[DataCur].nConfigs[n];
			}
		}


      temp=launchgame(DataCur,*pNoGames,FALSE);
		if(pMameGames[DataCur].bLocalConfig)
		{
			for(n=0;n<MAX_CFGS;n++)
				cfgDefValues[n].nValue=nSave[n];
		}
		return temp;

	}
	if(keys[K_COIN1]&&CurEmu==EMU_MAME)
	{
      if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
      {
         State=MENU_STATE_INFO;
         bFirstInfo=TRUE;
         bInstantInfo=TRUE;
         return FALSE;
      }
	}

//button 1, palyer2 - random game
   if(p2button1())
	{
      if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
		{
         writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
         CurPos=randomgame();
         OffSet[CurEmu]=0;
         cursorcheck();
			RandStart=1;
		}
		return FALSE;
	}
//change button, change emus
   if(keys[K_CHANGE]&&nNoEmulators>1)
   {
      changeemu(CurEmu+1);
      return FALSE;
   }
   if(keys[K_CLIST])
	{
      nextcustomlist();
		return FALSE;
	}

   if(keys[K_CUSTLIST])//&&nNoEmulators>1)
   {
      State=MENU_STATE_CUSTOM;
      return FALSE;
   }

   if(keys[K_EMULIST]&&nNoEmulators>1)
   {
      bExplodeEmu=TRUE;
      State=MENU_STATE_EMULATOR;
      EmuPos=CurEmu;
      return FALSE;
   }

	if(!MenuLocked)
	{
//button 2, palyer2 - Custom Lists
		if(keys[K_2_B2])
		{
         if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
			{
            bExplodeCustom=TRUE;
				CustInst=TRUE;
				CustPos=pMameGames[DataCur].Orientation>>4;
				State=MENU_STATE_CUSTOM_SET;
			}
			return FALSE;
		}

      if(Emulators[CurEmu].bSupportsRotation)
		{
//button 1, change the game's screen orientation
         if(keys[K_B1]&&Information==INFO_OFFSET+2&&!noButtonOn[0])
			{
            if(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]>0)
				{
               Orient=(pMameGames[DataCur].Orientation&7)+1;
               if(Orient>4)
                  Orient=0;
					pMameGames[DataCur].Orientation&=248;
               pMameGames[DataCur].Orientation|=Orient;
					pMameGames[DataCur].bChanged=TRUE;
				}
				return FALSE;
			}
//button 2, change which games are displayed
			if(keys[K_B2]&&!noButtonOn[1])
			{
            nLastGame[CurEmu]=-1;
            writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][*pDispRot]);

				*pDispRot+=1;
				if(*pDispRot>3)
					*pDispRot=0;

            readgamelist(*pDispRot);
            OffSet[CurEmu]=0;
				CurPos=0;
				return FALSE;
			}
//button 3, change the menu's screen orientation
			if(keys[K_B3]&&!noButtonOn[2])
			{
            temp=changemenuorient();
            nLastGame[CurEmu]=-1;
            writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][*pDispRot]);

				*pDispRot=temp;
            readgamelist(*pDispRot);
            OffSet[CurEmu]=0;
				CurPos=0;
                cursorcheck();
// DANNY REGO
				if(noUseLastShot||!haveshot())
                                  {
					setbackdrop();
displayLCDLogo();
                                  }
				return FALSE;
			}
		}

	}
	if(keys[K_LOCK])
	{
      MenuLocked=!MenuLocked;
		return FALSE;
	}
//handle cursor movement
    if(handlemovement(&CurPos,pNoGames,&OffSet[CurEmu],ScreenOrient.NoOnScreen))
		return -1;
   return -2;


}

int handlemovement(int *CPos,int *pNoGames,int *pOffSet,int NoInPage)
{
   int ypos;
   int nSavePos;
   int moving;
   int kpr=FALSE;

	ypos=*CPos-*pOffSet;
	nSavePos=*CPos;
   moving=0;
   if(keys[K_DOWN]||keys[K_DOWN2])
	{
      kpr=TRUE;
      if(*CPos<*pNoGames-1)
		{
         ypos++;
			if(ypos>=NoInPage)
			{
				if(*pOffSet+NoInPage<*pNoGames)
				{
					*pOffSet+=1;
					*CPos+=1;
				}
			}
			else
				*CPos+=1;
		}
      else
      {
         if(!noWrapMenus)
            *CPos=0;
      }
      moving=1;
      checkwhichplayer(K_DOWN);
	}
   if(keys[K_UP]||keys[K_UP2])
	{
      kpr=TRUE;
      if(*CPos>0)
		{
			ypos--;
			if(ypos<0)
				*pOffSet-=1;
			*CPos-=1;
		}
      else
      {
         if(!noWrapMenus)
            *CPos=*pNoGames-1;
      }
      moving=1;
      checkwhichplayer(K_UP);
	}
   if(keys[K_RIGHT]||keys[K_RIGHT2])
	{
      kpr=TRUE;
      if(!moving||!noDiagonals)
      {
         *CPos+=NoInPage;
         *pOffSet+=NoInPage;
      }
      if(!noWrapMenus)
      {
         if(*CPos>*pNoGames-1)
            *CPos=*CPos-*pNoGames;
      }
      checkwhichplayer(K_RIGHT);
	}
   if(keys[K_LEFT]||keys[K_LEFT2])
	{
      kpr=TRUE;
      if(!moving||!noDiagonals)
      {
         *CPos-=NoInPage;
         *pOffSet-=NoInPage;
      }
      if(!noWrapMenus)
      {
         if(*CPos<0)
            *CPos=*pNoGames+*CPos;
      }
      checkwhichplayer(K_LEFT);
	}
	if(State==MENU_STATE_GAMES)
      cursorcheck();
	else
	{
		if(*CPos>=*pNoGames)
		{
			*CPos=*pNoGames-1;
			*pOffSet=*CPos-NoInPage+1;
		}
		if(*pOffSet>=*pNoGames)
		{
			*CPos=*pNoGames-1;
			*pOffSet=*CPos-NoInPage;
		}
		if(*pOffSet+NoInPage>=*pNoGames)

			*pOffSet=*pNoGames-NoInPage;

		if(*CPos<0)
			*CPos=0;
		if(*pOffSet<0)
			*pOffSet=0;

	}
   if(kpr)
      RunState=0;
	if(*CPos!=nSavePos)
		return TRUE;

	return FALSE;
}

void cursorcheck(void)
{
   int nGames;

   nGames=Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION];
   while((CurPos-OffSet[CurEmu])>=ScreenOrient.NoOnScreen&&OffSet[CurEmu]<(nGames-ScreenOrient.NoOnScreen))
      OffSet[CurEmu]+=1;
    while(OffSet[CurEmu]>CurPos&&OffSet[CurEmu]>0)
        OffSet[CurEmu]-=1;
	if(CurPos<0)
		CurPos=0;
   if(OffSet[CurEmu]<0)
      OffSet[CurEmu]=0;

	if(CurPos>=nGames)
		CurPos=nGames-1;
   if(OffSet[CurEmu]+ScreenOrient.NoOnScreen>=nGames)
	{
      OffSet[CurEmu]=nGames-ScreenOrient.NoOnScreen;
      if(OffSet[CurEmu]<0)
         OffSet[CurEmu]=0;
	}
}

int changemenuorient()
{
	int	nNewOrient;
	int	nFact,ret;
	nNewOrient=ScreenOrient.Orientation;
	nNewOrient++;
	if(nNewOrient>ORIENT_MAX)
		nNewOrient=ORIENT_NORMAL;
	switch(nNewOrient)
	{
		case 1:
		case 2:
			ret=2;
			break;
		default:
			ret=1;

	}
   nOrient[CurEmu]=nNewOrient;

   setscreenorient();
	precalcfont();
//make sure the cursor and offset are okay
   nFact=OffSet[CurEmu]/ScreenOrient.NoOnScreen;
   OffSet[CurEmu]=nFact*ScreenOrient.NoOnScreen;
   while((CurPos<OffSet[CurEmu])&&(OffSet[CurEmu]))
	{
      OffSet[CurEmu]-=ScreenOrient.NoOnScreen;
      if(OffSet[CurEmu]<0)
         OffSet[CurEmu]=0;
	}

   if(CurPos-OffSet[CurEmu]>ScreenOrient.NoOnScreen)
      OffSet[CurEmu]=CurPos;
	return ret;
}





void setscreenorient(void)
{
   int temp;
   int fnt;


   fnt = (FontSize-FONT_OFFSET);
   if(!Hires)
      fnt=0;

   ScreenOrient.Orientation=nOrient[CurEmu];

   switch(fnt)
	{
		case	0:
			ScreenOrient.fx=6;
			ScreenOrient.mx=8;
			ScreenOrient.fy=8;
			ScreenOrient.fsize=2048;
         ScreenOrient.fpos=11264;
			ScreenOrient.yoff=8;
			ScreenOrient.xoff=12;
			break;
		case	1:
			ScreenOrient.fx=8;
			ScreenOrient.mx=8;
			ScreenOrient.fy=8;

			ScreenOrient.fsize=2048;
         ScreenOrient.fpos=9216;
			ScreenOrient.yoff=8;
         ScreenOrient.xoff=12;
			break;

		case 2:
			ScreenOrient.fx=8;
			ScreenOrient.mx=8;
			ScreenOrient.fy=12;
			ScreenOrient.fsize=3072;
         ScreenOrient.fpos=7168;
         switch(nOrient[CurEmu])
         {
            case ORIENT_NORMAL:
               ScreenOrient.yoff=0;
               ScreenOrient.xoff=10;
               break;
            case ORIENT_ROTATED_LEFT:
               ScreenOrient.yoff=6;
               ScreenOrient.xoff=4;
               break;
            case ORIENT_ROTATED_RIGHT:
               ScreenOrient.yoff=6;
               ScreenOrient.xoff=0;
               break;
         }
         break;
		case 3:
			ScreenOrient.fx=8;
			ScreenOrient.mx=8;
			ScreenOrient.fy=16;
			ScreenOrient.fsize=4096;
         ScreenOrient.fpos=4096;;
         if(nOrient[CurEmu]==ORIENT_NORMAL)
         {
            ScreenOrient.yoff=-6;
            ScreenOrient.xoff=12;
         }
         else
         {
            ScreenOrient.yoff=4;
            ScreenOrient.xoff=-4;
         }
			break;
	}


   switch(nOrient[CurEmu])
	{
		case ORIENT_ROTATED_RIGHT:
		case ORIENT_ROTATED_LEFT:
         ScreenOrient.xwinoff=8;
         ScreenOrient.ywinoff=12;
			temp=ScreenOrient.xoff;
			ScreenOrient.xoff=ScreenOrient.yoff;
			ScreenOrient.yoff=temp;

			if(Hires)
			{
				ScreenOrient.xpixel=640;
				ScreenOrient.ypixel=480;
            ScreenOrient.maxy=(71*8)/ScreenOrient.fy;
            ScreenOrient.maxx=(75*6)/ScreenOrient.fx;
            if(HiresWidthVer>ScreenOrient.maxx-2)
               HiresWidthVer=ScreenOrient.maxx-2;

            ScreenOrient.DispWidth=HiresWidthVer;

            ScreenOrient.xcalc=((79*6)/ScreenOrient.fx);
            ScreenOrient.ycalc=((79*8)/ScreenOrient.fy);
				ScreenOrient.xcalcwin=79;
				ScreenOrient.ycalcwin=79;
            ScreenOrient.NoOnScreen=((67*8)/ScreenOrient.fy);
            pWidthVar=&HiresWidthVer;
			}
			else
			{

				ScreenOrient.xpixel=320;
				ScreenOrient.ypixel=200;
				ScreenOrient.NoOnScreen=31;
            ScreenOrient.maxx=30;
            if(WidthVer>ScreenOrient.maxx-2)
               WidthVer=ScreenOrient.maxx-2;
            ScreenOrient.DispWidth=WidthVer;
				ScreenOrient.maxy=35;
				ScreenOrient.xcalc=32;
				ScreenOrient.ycalc=39;
				ScreenOrient.xcalcwin=32;
				ScreenOrient.ycalcwin=39;
            pWidthVar=&WidthVer;
			}
         break;
      case ORIENT_NORMAL:
         ScreenOrient.ywinoff=8;
         ScreenOrient.xwinoff=12;
         if(Hires)
         {
            ScreenOrient.xpixel=640;
				ScreenOrient.ypixel=480;
            ScreenOrient.NoOnScreen=(53*8)/ScreenOrient.fy;
				ScreenOrient.maxx=(100*6)/ScreenOrient.fx;
            ScreenOrient.maxy=(57*8)/ScreenOrient.fy;
            if(HiresWidthHor>ScreenOrient.maxx-2)
               HiresWidthHor=ScreenOrient.maxx-2;
            ScreenOrient.DispWidth=HiresWidthHor;
            pWidthVar=&HiresWidthHor;
         }
			else
			{
				ScreenOrient.xpixel=320;
				ScreenOrient.ypixel=200;
            ScreenOrient.NoOnScreen=19;
				ScreenOrient.maxy=22;
				ScreenOrient.maxx=49;
            if(WidthHor>ScreenOrient.maxx-2)
               WidthHor=ScreenOrient.maxx-2;
            ScreenOrient.DispWidth=WidthHor;
            pWidthVar=&WidthHor;
			}
	}
   ScreenOrient.memsize=ScreenOrient.xpixel*ScreenOrient.ypixel;
}






void reloadgames(int bMessage)
{
	int bSaveQuick;
	WINSTRUCT	rlwin;
	bSaveQuick=noInstantStart;
	noInstantStart=1;

	if(bMessage)
	{
      createwin(&rlwin,2,3,21,6,0,0);
		drawwindow(&rlwin,1,TRUE,TRUE,szVersion);
		dispstring(3,6,"Reloading Game List",ExtraColour,TRUE,0,0,DISP_FONT);
		flipscreen(FALSE);
	}

	freescreen();
   writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);

   createlist(&NoGames,ROTATION,0);
   CurPos=0;
   OffSet[CurEmu]=0;
	noInstantStart=bSaveQuick;
	allocscreen();
}


void setuprandomlist(int nGames)
{
   int n,i,rbrk;
   pBYTE pRandompicked;
   char workbuf[256];
   FILE *fin;
   if(pRandomList)
      myfree(pRandomList);
   pRandomList=(int *)myalloc(nGames*sizeof(int));
   sprintf(workbuf,"%s.rnd",Emulators[CurEmu].szEmuName);

   if(ReRun)
   {
      fin=fopen(workbuf,"rb");
      if(fin)
      {
         if(fread(pRandomList,1,nGames,fin)==nGames)
         {
            fclose(fin);
            return;
         }
         fclose(fin);
         unlink(workbuf);
      }
   }

   pRandompicked=(pBYTE)myalloc(nGames);
   RandomIdx=0;

   memset(pRandompicked,0,nGames);
//precalc a random list of all the games
   for(n=0;n<nGames;n++)
   {
      rbrk=0;
      while(TRUE)
      {
//assign random game
         pRandomList[n]=random()%nGames;
//check if it's been picked alread
         if(!pRandompicked[pRandomList[n]])
         {
            pRandompicked[pRandomList[n]]=1;
            loginfo(2,"Random game %d = %d",n,pRandomList[n]);
            break;
         }
         rbrk++;
//break case, tried n times and didn't get a good random game
         if(rbrk>60)
         {
            for(i=0;i<nGames;i++)
            {
               if(!pRandompicked[i])
               {
                  pRandomList[n]=i;
                  pRandompicked[i]=1;
                  loginfo(2,"Random Game %d = %d (forced)",n,pRandomList[n]);
                  break;
               }
            }
            break;
         }
      }
   }
   myfree(pRandompicked);
   fin=fopen(workbuf,"wb");
   if(fin)
   {
      fwrite(pRandomList,1,nGames,fin);
      fclose(fin);
   }
}

int randomgame(void)
{
   int ret;

   while(TRUE)
   {
      if(RandomIdx>=NoGames)
         RandomIdx=0;
      ret=pRandomList[RandomIdx++];
      if(ret<Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
         break;
   }
	return ret;
}

void showcustom(int nType)
{
	int	n;
	char buffer[64];
	WINSTRUCT	winstruct;
   createwin(&winstruct,3,3,22,NO_CUSTOM_LISTS,0,5);
	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;
	pStdPos=&CustPos;
	pStdMax=&CustMax;

	registerwindow(&winstruct);
	*buffer=0;
	switch(nType)
	{
      case SHOW_CUSTOM_LIST:
			strcpy(buffer,"Display Custom List");
			break;
      case CUSTOM_CHOOSE:
			strcpy(buffer,"Game is in List:");
			break;
	}
   drawwindow(&winstruct,WinColour,TRUE,bExplodeCustom,buffer);
	dispcursorbar(CustPos,0,20,4,5);
	for(n=0;n<NO_CUSTOM_LISTS;n++)
	{
      if(!noCustomContainsAll[CurEmu])
         sprintf(buffer,": (%d)",Emulators[CurEmu].nGameTotals[0][0]);
      else
         sprintf(buffer,": (%d)",Emulators[CurEmu].nGameTotals[n][0]);

		dispstring(4,5+n,Emulators[CurEmu].szCustomList[n],ForeColour,TRUE,0,0,DISP_FONT);
		dispstring(16,5+n,buffer,ForeColour,TRUE,0,0,DISP_FONT);
	}
	dispcentre(n+5,"Start 2 to Close",ExtraColour,4,20,TRUE,0,2,DISP_FONT);
	bExplodeCustom=FALSE;
}


void movecustom(int nType)
{
	int	dummy=0;
	int	actpos;
   int   Orient;
	int	nCust;


   if(startpressed())
	{

//check it makes sense
      if(nType==SHOW_CUSTOM_LIST)
		{
         if(CustPos!=CUSTOM_LIST)
			{
            nLastGame[CurEmu]=-1;
            writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
            CUSTOM_LIST=CustPos;
            readgamelist(ROTATION);
            OffSet[CurEmu]=0;
				CurPos=0;
            nLastGame[CurEmu]=-1;
				State=MENU_STATE_GAMES;
			}

		}
		else
		{

         if(CustPos==CUSTOM_LIST)
			{
				State=MENU_STATE_GAMES;
				return;
			}
         if(!Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
				return;

         actpos=CurPos;
			nCust=CustPos<<4;
         Orient=pMameGames[actpos].Orientation&7;
         Orient|=nCust;
         actpos=CurPos;
         pMameGames[actpos].Orientation=Orient;
			pMameGames[actpos].bChanged=TRUE;
         writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
//sort out the totals
         Emulators[CurEmu].nGameTotals[CUSTOM_LIST][0]-=1;
         switch(Orient)
			{
				case	0:
               Emulators[CurEmu].nGameTotals[CUSTOM_LIST][1]-=1;
					break;
				case	1:
				case	2:
				case	3:
               Emulators[CurEmu].nGameTotals[CUSTOM_LIST][2]-=1;
					break;
				case	4:
               Emulators[CurEmu].nGameTotals[CUSTOM_LIST][3]-=1;
			}


			Emulators[CurEmu].nGameTotals[CustPos][0]+=1;
         switch(Orient&7)
			{
				case	0:
					Emulators[CurEmu].nGameTotals[CustPos][1]+=1;
					break;
				case	1:
				case	2:
				case	3:
					Emulators[CurEmu].nGameTotals[CustPos][2]+=1;
					break;
				case	4:
					Emulators[CurEmu].nGameTotals[CustPos][3]+=1;
			}
         readgamelist(ROTATION);
         cursorcheck();

			if(CustInst)
				State=MENU_STATE_GAMES;
			else
				State=MENU_STATE_CONTROL;
         nLastGame[CurEmu]=-1;
		}
	}
	else
		handlemovement(&CustPos,&CustMax,&dummy,ScreenOrient.NoOnScreen);

}



void calibratetick(void)
{
	clock_t a;
	clock_t b;
	struct  time t;
	struct  time t2;
	int	secs=0;


	if(!clocks_per_second||ReRun)
	{
		a=clock();
		gettime(&t);
		while(secs!=2)
		{
			gettime(&t2);
			if(t.ti_sec!=t2.ti_sec)
			{
				memcpy(&t,&t2,sizeof(struct time));
				secs++;
			}

		}
		b=clock()-a;
		clocks_per_second=(clock_t)((double)b/2.0F);
	}
}



void setcfgidents(char *pIn,int offset)
{
   char bucket[32];
   int noitems,i;
   char *pWork;

   noitems=getitemcount(pIn,',');

   for(i=0;i<noitems;i++)
   {
      pWork=getitem(bucket,pIn,i,32,',');
      if(pWork)
         strcpy(pszTextValues[offset+i],pWork);
   }
}


void setinternalcfg(void)
{
   int n;
   char szDrive[2];

   setcfgidents("No,Right,Left",AUTO_ROTATE_OFFSET);
   setcfgidents("None,Standard,Trackball,Spinner",MOUSE_OFFSET);
   setcfgidents("Lens,Puzzle,Stars,Puzzle2,Screens,"
                  "Screens3D,SS.Lens,SS.Smear,SS.Explode,SS.Slats,Blank,JukeBox",SAVER_OFFSET);

   setcfgidents("Snap,Flyers,Cabinet",SCREEN_OFFSET);
   setcfgidents("6x8,8x8,8x12,8x16",FONT_OFFSET);
   setcfgidents("Standard,Pastel,Matrix,Blue",SCHEME_OFFSET);
   setcfgidents("Games,Games+Tot,Full,S.S.Only,S.S.+Name",INFO_OFFSET);
   setcfgidents("Start 1,Start 2",SHIFT_OFFSET);


   setupkeyvals();
   setupjoyvals();

   setcfgidents("Standard,Cycle,Random",SSHOT_OFFSET);
   setcfgidents("320x200,640x480",RES_OFFSET);
//drive letters
   szDrive[1]=0;
   for(n=0;n<26;n++)
   {
      szDrive[0]=65+n;
      strcpy(pszTextValues[FILE_OFFSET+n],szDrive);
   }

   setcfgidents("Centre,TopRight,BotRight,MidRight",SSPOS_OFFSET);
   setcfgidents("Normal,Red,Green,Blue,Grey",TINT_OFFSET);
   setcfgidents("Never,If Run,Always",START_OFFSET);
   setcfgidents("None,Short,Long,All",CAPITAL_OFFSET);
}

void checkdpmi(void)
{
	__dpmi_regs r;

	r.x.ax = 0x1600;
	__dpmi_int(0x2F, &r);
	if((r.h.al!=0)&&(r.h.al!=1)&&(r.h.al!=0x80)&&(r.h.al!=0xFF))
	{
      loginfo(1,"DPMI Server: Windows");
		WindowsDPMI=TRUE;
	}
	else
	{
      loginfo(1,"DPMI Server: CWSDPMI");
		WindowsDPMI=FALSE;
	}
}

void nextcustomlist(void)
{
   nLastGame[CurEmu]=-1;
   writegamelist(Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION]);
   CUSTOM_LIST+=1;
   if(CUSTOM_LIST>=NO_CUSTOM_LISTS)
      CUSTOM_LIST=0;
   readgamelist(ROTATION);
   OffSet[CurEmu]=0;
	CurPos=0;
}

void fontchanged(void)
{
    setscreenorient();
    clearfonts();
    initdisp();
    precalcfont();
    createwin(&ldwin,2,7,20,5,0,0);
    cfgDefValues[nWidthIndex].max=ScreenOrient.maxx-2;
    cfgDefValues[nWidthIndex].pArcValue=pWidthVar;
    nCfgValues[nWidthIndex]=*pWidthVar;
}

void schemechanged(void)
{
    setscheme();
    clearfonts();
    initdisp();
    precalcfont();
}


int isxmas(void)
{
   struct date dte;
   getdate(&dte);
   if(dte.da_mon==12&&dte.da_day>=20)
      return TRUE;
   return FALSE;
}

void exitaos(int nExit)
{
   InCabinet=SaveCab;
   writecfgvalues();
   exit(nExit);
}


