#ifndef _KEY_LC_H_
#define _KEY_LC_H_

SCANCODE sdef[NO_OF_KEYS]=
{
   {"kup",72},
   {"kdown",80},
   {"kleft",75},
   {"kright",77},
   {"kp1butt1",29},
   {"kp1butt2",56},
   {"kp1butt3",57},
   {"klock",38},
   {"kp2butt1",30},
   {"kexit",1},
   {"kp2start",4},
   {"kp1start",2},
   {"kcoin1",5},
   {"kclosewin",1},
   {"kp2butt3",16},
   {"kp2butt2",31},
   {"ksshot",88},
   {"knxtemu",7},
   {"knxtclist",8},
   {"kemulist",9},
   {"kcustlist",10},
   {"k2up",19},
   {"k2down",33},
   {"k2left",32},
   {"k2right",34}
};

static char scannames[][8]=
{
   "None",
   "Esc","1","2","3","4","5","6","7","8","9","0","-","=","BkSpc",
   "Tab","Q","W","E","R","T","Y","U","I","O","P","[","]","Return",
   "Ctrl","A","S","D","F","G","H","J","K","L",";","'","","LShift","#",
   "Z","X","C","V","B","N","M",",",".","/","RShift","*",
   "Alt","Space","CapsLk",
   "F1","F2","F3","F4","F5","F6","F7","F8","F9","F10",
   "NumLk","ScrLk",
   "Home","Up","PgUp","-",
   "Left","5","Right","+",
   "End","Down","PgDn","Ins","Del",
   "undef.","undef.","undef.",
   "F11","F12"
};


static char dispkey[NO_OF_KEYS][16]=
{
   "Move Up",
   "Move Down",
   "Page Up",
   "Page Down",
   "games orient.",
   "games shown",
   "Orient.of AOS",
   "Lock ArcadeOS",
   "Random Game",
   "Exit ArcadeOS",
   "Control Menu",
   "Run Game",
   "Game Info",
   "Close popups",
   "Online help",
   "Custom List",
   "Screen shot",
   "Change emu",
   "Change list",
   "Emu Menu",
   "Clist Menu",
   "Move Up 2",
   "Move Down 2",
   "Page Up 2",
   "Page Down 2"
};

static char dispshift[][16]=
{
   "Shift+Pl b1",
   "Shift+Pl b2",
   "Shift+Pl b3",
   "Shift+P2 b1",
   "Shift+P2 b2",
   "Shift+P2 b3"
};

#endif
